// DragDropLineCounterDlg.cpp
/*
 *  Copyright (c) 2008-2011 Leigh Johnston.
 *
 *  All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are
 *  met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *
 *     * Neither the name of Leigh Johnston nor the names of any
 *       other contributors to this software may be used to endorse or
 *       promote products derived from this software without specific prior
 *       written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS
 *  IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 *  THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 *  PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 *  CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 *  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 *  PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 *  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
 *  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
 *  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 *  SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

#include "stdafx.h"
#include "DragDropLineCounter.h"
#include "DragDropLineCounterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDragDropLineCounterDlg dialog

CDragDropLineCounterDlg::CDragDropLineCounterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDragDropLineCounterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDragDropLineCounterDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDragDropLineCounterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDragDropLineCounterDlg)
	DDX_Control(pDX, IDC_FILE_PROGRESS, m_ctrlFileProgress);
	DDX_Control(pDX, IDC_TOTAL_LINES, m_ctrlTotalLines);
	DDX_Control(pDX, IDC_TOTAL_FILES, m_ctrlTotalFiles);
	DDX_Control(pDX, IDC_TOTAL_CHARACTERS, m_ctrlTotalCharacters);
	DDX_Control(pDX, IDC_PROGRESS, m_ctrlProgress);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDragDropLineCounterDlg, CDialog)
	//{{AFX_MSG_MAP(CDragDropLineCounterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DROPFILES()
	ON_WM_TIMER()
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDRESET, OnReset)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDragDropLineCounterDlg message handlers

BOOL CDragDropLineCounterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	DragAcceptFiles();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_ctrlTotalLines.SetFocus();

	SetWindowPos(&wndTopMost, 0, 0, 0, 0, SWP_NOSIZE|SWP_NOMOVE);
	
	return FALSE;  // return TRUE  unless you set the focus to a control
}

void CDragDropLineCounterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDragDropLineCounterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDragDropLineCounterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDragDropLineCounterDlg::OnDropFiles(HDROP hDropInfo) 
{
	UINT nCount = DragQueryFile(hDropInfo, -1, NULL, 0);
	char pathBuffer[MAX_PATH+1];
	for (size_t i = 0; i < nCount; ++i)
	{
		UINT pathLength = DragQueryFileA(hDropInfo, i, pathBuffer, sizeof(pathBuffer));
		iEngine.add_file(pathBuffer);
	}
	DragFinish(hDropInfo);
}

void CDragDropLineCounterDlg::OnTimer(UINT nIDEvent) 
{
	if (iEngine.analyzing())
	{
		m_ctrlProgress.ShowWindow(SW_SHOW);
		m_ctrlProgress.SetRange(0, 100);
		m_ctrlProgress.SetPos(iEngine.progress());
		m_ctrlFileProgress.ShowWindow(SW_SHOW);
		m_ctrlFileProgress.SetRange(0, 100);
		m_ctrlFileProgress.SetPos(iEngine.file_progress());
	}
	else
	{
		m_ctrlProgress.ShowWindow(SW_HIDE);
		m_ctrlFileProgress.ShowWindow(SW_HIDE);
	}

	unsigned long files, failures, characters, lines;
	iEngine.results(files, failures, characters, lines);
	int startChar, endChar;
	m_ctrlTotalLines.GetSel(startChar, endChar);
	m_ctrlTotalLines.SetWindowText(lib::unsigned_integer_to_string<wchar_t>(lines).c_str());
	m_ctrlTotalLines.SetSel(startChar, endChar);
	m_ctrlTotalFiles.GetSel(startChar, endChar);
	std::wstring fileCount = lib::unsigned_integer_to_string<wchar_t>(files);
	if (failures != 0)
		fileCount = fileCount + L" (" + lib::unsigned_integer_to_string<wchar_t>(failures) + L" failed to open)";
	m_ctrlTotalFiles.SetWindowText(fileCount.c_str());
	m_ctrlTotalFiles.SetSel(startChar, endChar);
	m_ctrlTotalCharacters.GetSel(startChar, endChar);
	m_ctrlTotalCharacters.SetWindowText(lib::unsigned_integer_to_string<wchar_t>(characters).c_str());
	m_ctrlTotalCharacters.SetSel(startChar, endChar);

	CDialog::OnTimer(nIDEvent);
}

int CDragDropLineCounterDlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;

	SetTimer(0x1234, 100, NULL);
	
	return 0;
}

void CDragDropLineCounterDlg::OnDestroy() 
{
	CDialog::OnDestroy();

	KillTimer(0x1234);
}

void CDragDropLineCounterDlg::OnReset() 
{
	iEngine.reset();
}
